{$if not def GRAPHICS_CLIP_H} CONST GRAPHICS_CLIP_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "graphics/clip.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_ClipRect = ^ClipRect;
TYPE p_Layer = ^Layer;

{$if not def GRAPHICS_RASTPORT_H;incl "graphics/rastport.h";endif}
{$if not def GRAPHICS_GFX_H;incl "graphics/gfx.h";endif}
{$if not def GRAPHICS_REGIONS_H;incl "graphics/regions.h";endif}
{ if not def GRAPHICS_LAYERS_H;incl "graphics/layers.h";endif}
{$if not def EXEC_SEMAPHORES_H;incl "exec/semaphores.h";endif}
{$if not def UTILITY_HOOKS_H;incl "utility/hooks.h";endif}


CONST NEWLOCKS = 0;


TYPE Layer  = RECORD
 front              : p_Layer;
 back               : p_Layer;
 ClipRect           : p_ClipRect;
 rp                 : p_RastPort;
 bounds             : Rectangle;
 reserved           : ARRAY[0..3] OF Byte;
 priority           : Word;
 Flags              : Word;
 SuperBitMap        : p_BitMap;
 SuperClipRect      : p_ClipRect;
 Window             : Ptr;
 Scroll_X           : Integer;
 Scroll_Y           : Integer;
 cr                 : p_ClipRect;
 cr2                : p_ClipRect;
 crnew              : p_ClipRect;
 SuperSaveClipRects : p_ClipRect;
 _cliprects         : p_ClipRect;
 LayerInfo          : p_Layer_Info;
 Lock               : SignalSemaphore;
 BackFill           : p_Hook;
 reserved1          : Long;
 ClipRegion         : p_Region;
 saveClipRects      : p_Region;
 Width              : Integer;
 Height             : Integer;
 reserved2          : ARRAY[0..17] OF Byte;
 DamageList         : p_Region;
END;

TYPE ClipRect = RECORD
 Next     : p_ClipRect;
 prev     : p_ClipRect;
 lobs     : p_Layer;
 BitMap   : p_BitMap;
 bounds   : Rectangle;
 _p1      : p_ClipRect;
 _p2      : p_ClipRect;
 reserved : LongInt;
{$if def NEWCLIPRECTS_1_1}
 Flags    : LongInt;
{$endif}
END;

CONST
 CR_NEEDS_NO_CONCEALED_RASTERS = 1;
 CR_NEEDS_NO_LAYERBLIT_DAMAGE  = 2;

CONST
 ISLESSX = 1;
 ISLESSY = 2;
 ISGRTRX = 4;
 ISGRTRY = 8;


{$endif}
