{$if not def GRAPHICS_DISPLAYINFO_H} CONST GRAPHICS_DISPLAYINFO_H=0;

{ ************************************************************************
  ** KickPascal-Include-Datei "graphics/displayinfo.h" zu Kickstart 3.0 **
  ************************************************************************ }

TYPE DisplayInfoHandle = Ptr;
TYPE p_QueryHeader = ^QueryHeader;
TYPE p_DisplayInfo = ^DisplayInfo;
TYPE p_DimensionInfo = ^DimensionInfo;
TYPE p_MonitorInfo = ^MonitorInfo;
TYPE p_NameInfo =  ^NameInfo;

{$if not def GRAPHICS_GFX_H;incl "graphics/gfx.h";endif}
{$if not def GRAPHICS_MONITOR_H;incl "graphics/monitor.h";endif}
{$if not def UTILITY_TAGITEM_H;incl "utility/tagitem.h";endif}


CONST
 DTAG_DISP  = $80000000;
 DTAG_DIMS  = $80001000;
 DTAG_MNTR  = $80002000;
 DTAG_NAME  = $80003000;
 DTAG_VEC   = $80004000;


TYPE QueryHeader = RECORD
 StructID  : Long;
 DisplayID : Long;
 SkipID    : Long;
 Length    : Long;
END;

TYPE DisplayInfo = RECORD
 Header           : QueryHeader;
 NotAvailable     : Word;
 PropertyFlags    : Long;
 Resolution       : tPoint;
 PixelSpeed       : Word;
 NumStdSprites    : Word;
 PaletteRange     : Word;
 SpriteResolution : tPoint;
 pad              : ARRAY[0..3] OF Byte;
 RedBits          : Byte;
 GreenBits        : Byte;
 BlueBits         : Byte;
 pad2             : ARRAY[0..4] OF Byte;
 reserved         : ARRAY[0..1] OF Long;
END;

CONST
 DI_AVAIL_NOCHIPS        = $0001;
 DI_AVAIL_NOMONITOR      = $0002;
 DI_AVAIL_NOTWITHGENLOCK = $0004;

CONST
 DIPF_IS_LACE           = $00000001;
 DIPF_IS_DUALPF         = $00000002;
 DIPF_IS_PF2PRI         = $00000004;
 DIPF_IS_HAM            = $00000008;

 DIPF_IS_ECS            = $00000010;
 DIPF_IS_AA             = $00010000;

 DIPF_IS_PAL            = $00000020;
 DIPF_IS_SPRITES        = $00000040;
 DIPF_IS_GENLOCK        = $00000080;

 DIPF_IS_WB             = $00000100;
 DIPF_IS_DRAGGABLE      = $00000200;
 DIPF_IS_PANELLED       = $00000400;
 DIPF_IS_BEAMSYNC       = $00000800;

 DIPF_IS_EXTRAHALFBRITE = $00001000;

 DIPF_IS_SPRITES_ATT       = $00002000;
 DIPF_IS_SPRITES_CHNG_RES  = $00004000;
 DIPF_IS_SPRITES_BORDER    = $00008000;
 DIPF_IS_SCANDBL           = $00020000;
 DIPF_IS_SPRITES_CHNG_BASE = $00040000;

 DIPF_IS_DBUFFER        = $00100000;
 DIPF_IS_PROGBEAM       = $00200000;
 DIPF_IS_FOREIGN        = $80000000;

{$if not def GRAPHICS_MODEID_H;incl "graphics/modeid.h";endif}

TYPE DimensionInfo = RECORD
 Header          : QueryHeader;
 MaxDepth        : Word;
 MinRasterWidth  : Word;
 MinRasterHeight : Word;
 MaxRasterWidth  : Word;
 MaxRasterHeight : Word;
 Nominal         : Rectangle;
 MaxOScan        : Rectangle;
 VideoOScan      : Rectangle;
 TxtOScan        : Rectangle;
 StdOScan        : Rectangle;
 pad             : ARRAY[0..13] OF Byte;
 reserved        : ARRAY[0..1] OF Long;
END;

TYPE MonitorInfo = RECORD
 Header              : QueryHeader;
 Mspc                : p_MonitorSpec;
 ViewPosition        : tPoint;
 ViewResolution      : tPoint;
 ViewPositionRange   : Rectangle;
 TotalRows           : Word;
 TotalColorClocks    : Word;
 MinRow              : Word;
 Compatibility       : Integer;
 pad                 : ARRAY[0..35] OF Byte;
 DefaultViewPosition : Point;
 PreferredModeID     : Long;
  reserved            : ARRAY[0..1] OF Long;
END;

CONST
 MCOMPAT_MIXED  = 0;
 MCOMPAT_SELF   = 1;
 MCOMPAT_NOBODY = -1;

CONST DISPLAYNAMELEN = 32;

TYPE NameInfo = RECORD
 Header   : QueryHeader;
 Name     : String[DISPLAYNAMELEN];
 reserved : ARRAY[0..1] OF Long;
END;


TYPE VecInfo = RECORD
 Header : QueryHeader;
 Vec    : Ptr;
 Data   : Ptr;
 _Type  : Word; { "_" ergnzt }
 pad    : ARRAY[0..2] of Word;
 reserved : ARRAY[0..1] of Long;
end;

{$endif}
