{$if not def GRAPHICS_GELS_H} CONST GRAPHICS_GELS_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "graphics/gels.h" zu Kickstart 3.0 **
  ***************************************************************** }

{$if not def VUserStuff}
TYPE VUserStuff = Integer;
{$endif}
{$if not def BUserStuff}
TYPE BUserStuff = Integer;
{$endif}
{$if not def AUserStuff}
TYPE AUserStuff = Integer;
{$endif}


TYPE p_Bob = ^Bob;
TYPE p_AnimComp = ^AnimComp;
TYPE p_DBufPacket = ^DBufPacket;
TYPE p_AnimOb = ^AnimOb;
TYPE p_VSprite = ^VSprite;
TYPE p_collTable = ^collTable;



CONST
 SUSERFLAGS   = $00FF;
 _VSPRITE     = $0001; { "_" ergnzt }
 SAVEBACK     = $0002;
 OVERLAY      = $0004;
 MUSTDRAW     = $0008;
 BACKSAVED    = $0100;
 BOBUPDATE    = $0200;
 GELGONE      = $0400;
 VSOVERFLOW   = $0800;

 BUSERFLAGS   = $00FF;
 SAVEBOB      = $0001;
 BOBISCOMP    = $0002;

 BWAITING     = $0100;
 BDRAWN       = $0200;
 BOBSAWAY     = $0400;
 BOBNIX       = $0800;
 SAVEPRESERVE = $1000;
 OUTSTEP      = $2000;

CONST
 ANFRACSIZE  = 6;
 ANIMHALF    = $0020;
 RINGTRIGGER = $0001;


TYPE VSprite = RECORD
 NextVSprite : p_VSprite;
 PrevVSprite : p_VSprite;
 DrawPath    : p_VSprite;
 ClearPath   : p_VSprite;
 OldY        : Integer;
 OldX        : Integer;
 Flags       : Integer;
 Y           : Integer; 
 X           : Integer;
 Height      : Integer;
 Width       : Integer;
 Depth       : Integer;
 MeMask      : Integer;
 HitMask     : Integer;
 ImageData   : Ptr;
 BorderLine  : Ptr;
 CollMask    : Ptr;
 SprColors   : Ptr;
 VSBob       : p_Bob;
 PlanePick   : Short;
 PlaneOnOff  : Short;
 VUserExt    : VUserStuff;
END;


TYPE Bob = RECORD
 Flags       : Integer;
 SaveBuffer  : Ptr;
 ImageShadow : Ptr;
 Before      : p_Bob;
 After       : p_Bob;
 BobVSprite  : p_VSprite;
 BobComp     : p_AnimComp;
 DBuffer     : p_DBufPacket;
 BUserExt    : BUserStuff;
END;


TYPE AnimComp = RECORD
 Flags        : Integer;
 Timer        : Integer;
 TimeSet      : Integer;
 NextComp     : p_AnimComp;
 PrevComp     : p_AnimComp;
 NextSeq      : p_AnimComp;
 PrevSeq      : p_AnimComp;
 AnimCRoutine : Ptr;
 YTrans       : Integer;
 XTrans       : Integer;
 HeadOb       : p_AnimOb;
 AnimBob      : p_Bob;
END;

TYPE AnimOb = RECORD
 NextOb       : p_AnimOb;
 PrevOb       : p_AnimOb;
 Clock        : LongInt;
 AnOldY       : Integer;
 AnOldX       : Integer;
 AnY          : Integer;
 AnX          : Integer;
 YVel         : Integer;
 XVel         : Integer;
 YAccel       : Integer;
 XAccel       : Integer;
 RingYTrans   : Integer;
 RingXTrans   : Integer;
 AnimORoutine : Ptr;
 HeadComp     : p_AnimComp;
 AUserExt     : AUserStuff;
END;

TYPE DBufPacket = RECORD
 BufY      : Integer;
 BufX      : Integer;
 BufPath   : p_VSprite;
 BufBuffer : ^Integer;
END;


CONST
 B2NORM   = 0;
 B2SWAP   = 1;
 B2BOBBER = 2;

TYPE collTable = RECORD 
 collPtrs : ARRAY[0..15] OF Ptr;
END;

{$endif}
