{$if not def GRAPHICS_GFXBASE_H} CONST GRAPHICS_GFXBASE_H=0;

{ ********************************************************************
  ** KickPascal-Include-Datei "graphics/gfxbase.h" zu Kickstart 3.0 **
  ******************************************************************** }

{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_LIBRARIES_H;incl "exec/libraries.h";endif}
{$if not def EXEC_INTERRUPTS_H;incl "exec/interrupts.h";endif}
{$if not def GRAPHICS_MONITOR_H;incl "graphics/monitor.h";endif}
{$if not def GRAPHICS_VIEW_H;incl "graphics/view.h";endif}
{$if not def GRAPHICS_COPPER_H;incl "graphics/copper.h";endif}
{$if not def GRAPHICS_TEXT_H;incl "graphics/text.h";endif}
{$if not def HARDWARE_BLIT_H;incl "hardware/blit.h";endif}


TYPE p_GfxBase = ^_GfxBase; { "_" ergnzt }

TYPE _GfxBase = RECORD
 LibNode          : _Library;
 ActiView         : p_View;
 copinit          : p_copinit;
 cia              : Ptr;
 blitter          : Ptr;
 LOFlist          : Ptr;
 SHFlist          : Ptr;
 blthd            : p_bltnode;
 blttl            : p_bltnode;
 bsblthd          : p_bltnode;
 bsblttl          : p_bltnode;
 vbsrv            : Interrupt;
 timsrv           : Interrupt;
 bltsrv           : Interrupt;
 TextFonts        : List;
 DefaultFont      : p_TextFont;
 Modes            : Word;
 VBlank           : Short;
 Debug            : Short;
 BeamSync         : Integer;
 system_bplcon0   : Integer;
 SpriteReserved   : Byte;
 bytereserved     : Byte;
 Flags            : Word;
 BlitLock         : Integer;
 BlitNest         : Integer;
 BlitWaitQ        : List;
 BlitOwner        : p_Task;
 TOF_WaitQ        : List;
 DisplayFlags     : Word;
 SimpleSprites    : ^Ptr;
 MaxDisplayRow    : Word;
 MaxDisplayColumn : Word;
 NormalDisplayRows: Word;
 NormalDisplayColumns: Word;
 NormalDPMX       : Word;
 NormalDPMY       : Word;
 LastChanceMemory : p_SignalSemaphore;
 LCMptr           : Ptr;
 MicrosPerLine    : Word;
 MinDisplayColumn : Word;
 ChipRevBits0     : Byte;
 crb_reserved     : ARRAY[0..2] OF Byte;
 monitor_id       : Word;
 hedley           : ARRAY[0..7] OF Long;
 hedley_sprites   : ARRAY[0..7] OF Long;
 hedley_sprites1  : ARRAY[0..7] OF Long;
 hedley_count     : Integer;
 hedley_flags     : Word;
 hedley_tmp       : Integer;
 hash_table       : Ptr;
 current_tot_rows : Word;
 current_tot_cclks: Word;
 hedley_hint      : Byte;
 hedley_hint2     : Byte;
 nreserved        : ARRAY[0..3] OF Long;
 a2024_sync_raster: Ptr;
 control_delta_pal: Integer;
 control_delta_ntsc: Integer;
 current_monitor  : p_MonitorSpec;
 MonitorList      : List;
 default_monitor  : p_MonitorSpec;
 MonitorListSemaphore : p_SignalSemaphore;
 DisplayInfoDataBase  : Ptr;
 ActiViewCprSemaphore : p_SignalSemaphore;
 UtilityBase      : Ptr;
 ExecBase         : Ptr;
 bwshifts         : Byte;
 StrtFetchMasks   : Word;
 StopFetchMasks   : Word;
 Overrun          : Word;
 RealStops        : Integer;
 SpriteWidth      : Word;
 SpriteFMode      : Word;
 SoftSprites      : Short;
 arraywidth       : Short;
 DefaultSpriteWidth : Word;
 SprMoveDisable   : Short;
 WantChips        : Byte;
 BoardMemType     : Byte;
 Bugs             : Byte;
 gb_LayerBase     : Ptr;
 ColorMask        : Long;
 IVector          : Ptr;
 IData            : Ptr;
 SpecialCounter   : Long;
 DBList           : Ptr;
 MonitorFlags     : Word;
 ScanDoubledSprites : Byte;
 BP3Bits          : Byte;
 MonitorVBlank    : AnalogSignalInterval;
 natural_monitor  : MonitorSpec;
 ProgData         : Ptr;
 ExtSprites       : Byte;
END;

CONST
 NTSC       =  1;
 GENLOC     =  2;
 PAL        =  4;
 TODA_SAFE  =  8;
 REALLY_PAL = 16;

CONST
 BLITMSG_FAULT = 4;

CONST
 GFXB_BIG_BLITS = 0;
 GFXB_HR_AGNUS  = 0;
 GFXB_HR_DENISE = 1;
 GFXB_AA_ALICE  = 2;
 GFXB_AA_LISA   = 3;
 GFXB_AA_MLISA  = 4;

 GFXF_BIG_BLITS =  1;
 GFXF_HR_AGNUS  =  1;
 GFXF_HR_DENISE =  2;
 GFXF_AA_ALICE  =  4;
 GFXF_AA_LISA   =  8;
 GFXF_AA_MLISA  = 16;

 SETCHIPREV_A   = GFXF_HR_AGNUS;
 SETCHIPREV_ECS = (GFXF_HR_AGNUS or GFXF_HR_DENISE);
 SETCHIPREV_AA  = (GFXF_AA_ALICE or GFXF_AA_LISA or SETCHIPREV_ECS);
 SETCHIPREV_BEST= $ffffffff;

 BUS_16         = 0;
 NML_CAS        = 0;
 BUS_32         = 1;
 DBL_CAS        = 2;
 BANDWIDTH_1X   = (BUS_16 or NML_CAS);
 BANDWIDTH_2XNML= BUS_32;
 BANDWIDTH_2XDBL= DBL_CAS;
 BANDWIDTH_4X   = (BUS_32 or DBL_CAS);

CONST GRAPHICSNAME = "graphics.library";

{$endif}
