{$if not def GRAPHICS_MONITOR_H} CONST GRAPHICS_MONITOR_H=0;

{ ********************************************************************
  ** KickPascal-Include-Datei "graphics/monitor.h" zu Kickstart 3.0 **
  ******************************************************************** }

TYPE p_SpecialMonitor = ^SpecialMonitor;
TYPE p_MonitorSpec = ^MonitorSpec;
TYPE p_AnalogSignalInterval = ^AnalogSignalInterval;

{$if not def EXEC_SEMAPHORES_H;incl "exec/semaphores.h";endif}
{$if not def GRAPHICS_GFXNODES_H;incl "graphics/gfxnodes.h";endif}
{$if not def GRAPHICS_GFX_H;incl "graphics/gfx.h";endif}
{$if not def HARDWARE_CUSTOM_H;incl "hardware/custom.h";endif}


TYPE MonitorSpec = RECORD
 ms_Node             : ExtendedNode;
 ms_Flags            : Word;
 ratioh              : LongInt;
 ratiov              : LongInt;
 total_rows          : Word;
 total_colorclocks   : Word;
 DeniseMaxDisplayColumn : Word;
 BeamCon0            : Word;
 min_row             : Word;
 ms_Special          : p_SpecialMonitor;
 ms_OpenCount        : Word;
 ms_transform        : Ptr;
 ms_translate        : Ptr;
 ms_scale            : Ptr;
 ms_xoffset          : Word;
 ms_yoffset          : Word;
 ms_LegalView        : Rectangle;
 ms_maxoscan         : Ptr;
 ms_videoscan        : Ptr;
 DeniseMinDisplayColumn : Word;
 DisplayCompatible   : Long;
 DisplayInfoDataBase : List;
 DisplayInfoDataBaseSemaphore : SignalSemaphore;
 ms_MrgCop           : Ptr;
 ms_LoadView         : Ptr;
 ms_KillView         : Ptr;
END;

CONST
 TO_MONITOR       = 0;
 FROM_MONITOR     = 1;
 STANDARD_XOFFSET = 9;
 STANDARD_YOFFSET = 0;

 MSB_REQUEST_NTSC    = 0;
 MSB_REQUEST_PAL     = 1;
 MSB_REQUEST_SPECIAL = 2;
 MSB_REQUEST_A2024   = 3;
 MSB_DOUBLE_SPRITES  = 4;
 MSF_REQUEST_NTSC    = $1;
 MSF_REQUEST_PAL     = $2;
 MSF_REQUEST_SPECIAL = $4;
 MSF_REQUEST_A2024   = $8;
 MSF_DOUBLE_SPRITES  = $10;

{ alte V37 Namen, nicht mehr benutzen }

 REQUEST_NTSC     = 1;
 REQUEST_PAL      = 2;
 REQUEST_SPECIAL  = 4;
 REQUEST_A2024    = 8;
 

CONST
 DEFAULT_MONITOR_NAME = "default.monitor";
 NTSC_MONITOR_NAME    = "ntsc.monitor";
 PAL_MONITOR_NAME     = "pal.monitor";
 STANDARD_MONITOR_MASK = (REQUEST_NTSC or REQUEST_PAL);


CONST
 STANDARD_NTSC_ROWS    = 262;
 STANDARD_PAL_ROWS     = 312;
 STANDARD_COLORCLOCKS  = 226;
 STANDARD_DENISE_MAX   = 455;
 STANDARD_DENISE_MIN   = 93;
 STANDARD_NTSC_BEAMCON = $0000;
 STANDARD_PAL_BEAMCON  = DISPLAYPAL;

 SPECIAL_BEAMCON  = (VARVBLANK or LOLDIS or VARVSYNC or VARBEAM or CSBLANK or VSYNCTRUE);

CONST
 MIN_NTSC_ROW    = 21;
 MIN_PAL_ROW     = 29;
 STANDARD_VIEW_X = $81;
 STANDARD_VIEW_Y = $2C;
 STANDARD_HBSTRT = $06;
 STANDARD_HSSTRT = $0B;
 STANDARD_HSSTOP = $1C;
 STANDARD_HBSTOP = $2C;
 STANDARD_VBSTRT = $0122;
 STANDARD_VSSTRT = $02A6;
 STANDARD_VSSTOP = $03AA;
 STANDARD_VBSTOP = $1066;

CONST
 VGA_COLORCLOCKS = 113; { = STANDARD_COLORCLOCKS/2 }
 VGA_TOTAL_ROWS  = (STANDARD_NTSC_ROWS*2);
 VGA_DENISE_MIN  = 59;
 MIN_VGA_ROW     = 29;
 VGA_HBSTRT      = $08;
 VGA_HSSTRT      = $0E;
 VGA_HSSTOP      = $1C;
 VGA_HBSTOP      = $1E;
 VGA_VBSTRT      = $0000;
 VGA_VSSTRT      = $0153;
 VGA_VSSTOP      = $0235;
 VGA_VBSTOP      = $0CCD;

CONST
 VGA_MONITOR_NAME = "vga.monitor";

CONST
 VGA70_COLORCLOCKS = 113; { = STANDARD_COLORCLOCKS/2 }
 VGA70_TOTAL_ROWS  = 449;
 VGA70_DENISE_MIN  = 59;
 MIN_VGA70_ROW     = 35;
 VGA70_HBSTRT      = $08;
 VGA70_HSSTRT      = $0E;
 VGA70_HSSTOP      = $1C;
 VGA70_HBSTOP      = $1E;
 VGA70_VBSTRT      = $0000;
 VGA70_VSSTRT      = $02A6;
 VGA70_VSSTOP      = $0388;
 VGA70_VBSTOP      = $0F73;

CONST
 VGA70_BEAMCON = $1a8a; { =SPECIAL_BEAMCON EOR VSYNCTRUE}
 VGA70_MONITOR_NAME = "vga70.monitor";

CONST
 BROADCAST_HBSTRT  = $01;
 BROADCAST_HSSTRT  = $06;
 BROADCAST_HSSTOP  = $17;
 BROADCAST_HBSTOP  = $27;
 BROADCAST_VBSTRT  = $0000;
 BROADCAST_VSSTRT  = $02A6;
 BROADCAST_VSSTOP  = $054C;
 BROADCAST_VBSTOP  = $1C40;
 BROADCAST_BEAMCON = (LOLDIS or CSBLANK);
 RATIO_FIXEDPART   = 4;
 RATIO_UNITY       = $10;


TYPE AnalogSignalInterval = RECORD
 asi_Start : Word;
 asi_Stop  : Word;
END;

TYPE SpecialMonitor = RECORD
 spm_Node   : ExtendedNode;
 spm_Flags  : Word;
 do_monitor : Ptr;
 reserved1  : Ptr;
 reserved2  : Ptr;
 reserved3  : Ptr;
 hblank     : AnalogSignalInterval;
 vblank     : AnalogSignalInterval;
 hsync      : AnalogSignalInterval;
 vsync      : AnalogSignalInterval;
END;

{$endif}
