{$if not def GRAPHICS_RASTPORT_H} CONST GRAPHICS_RASTPORT_H=0;

{ *********************************************************************
  ** KickPascal-Include-Datei "graphics/rastport.h" zu Kickstart 3.0 **
  ********************************************************************* }

TYPE p_AreaInfo = ^AreaInfo;
TYPE p_TmpRas = ^TmpRas;
TYPE p_GelsInfo = ^GelsInfo;
TYPE p_RastPort = ^RastPort;

{$if not def GRAPHICS_GFX_H;incl "graphics/gfx.h";endif}
{$if not def GRAPHICS_TEXT_H;incl "graphics/text.h";endif}
{$if not def GRAPHICS_LAYERS_H;incl "graphics/layers.h";endif}
{$if not def GRAPHICS_GELS_H;incl "graphics/gels.h";endif}

TYPE AreaInfo = RECORD
 VctrTbl  : Ptr;
 VctrPtr  : Ptr;
 FlagTbl  : Ptr;
 FlagPtr  : Ptr;
 Count    : Integer;
 MaxCount : Integer;
 FirstX   : Integer;
 FirstY   : Integer;
END;

TYPE TmpRas = RECORD
 RasPtr : Ptr;
 Size   : LongInt;
END;

TYPE GelsInfo = RECORD
 sprRsrvd      : Short;
 Flags         : Byte;
 gelHead       : p_VSprite;
 gelTail       : p_VSprite;
 nextLine      : Ptr;
 lastColor     : Ptr;
 collHandler   : p_collTable;
 leftmost      : Integer;
 rightmost     : Integer;
 topmost       : Integer;
 bottommost    : Integer;
 firstBlissObj : Ptr;
 lastBlissObj  : Ptr;
END;

TYPE RastPort = RECORD
 Layer        : p_Layer;
 BitMap       : p_BitMap;
 AreaPtrn     : Ptr;
 TmpRas       : p_TmpRas;
 AreaInfo     : p_AreaInfo;
 GelsInfo     : p_GelsInfo;
 Mask         :  Byte;
 FgPen        : Short;
 BgPen        : Short;
 AOlPen       : Short;
 DrawMode     : Short;
 AreaPtSz     : Short;
 linpatcnt    : Short;
 dummy        : Short;
 Flags        : Word;
 LinePtrn     : Word;
 cp_x         : Integer;
 cp_y         : Integer;
 minterms     : ARRAY[0..7] OF Byte;
 PenWidth     : Integer;
 PenHeight    : Integer;
 Font         : p_TextFont;
 AlgoStyle    : Byte;
 TxFlags      : Byte;
 TxHeight     : Word;
 TxWidth      : Word;
 TxBaseline   : Word;
 TxSpacing    : Integer;
 RP_User      : Ptr;
 longreserved : ARRAY[0..1] OF LongInt;
{$if not def GFX_RASTPORT_1_2}
 wordreserved : ARRAY[0..6] OF Word;
 reserved     : ARRAY[0..7] OF Byte;
{$endif}
END;

CONST
 JAM1       = 0;
 JAM2       = 1;
 COMPLEMENT = 2;
 INVERSVID  = 4;

CONST
 FRST_DOT    = $01;
 ONE_DOT     = $02;
 DBUFFER     = $04;
 AREAOUTLINE = $08;
 NOCROSSFILL = $20;

{$endif}
