{$if not def GRAPHICS_TEXT_H} CONST GRAPHICS_TEXT_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "graphics/text.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_TextAttr = ^TextAttr;
TYPE p_TTextAttr = ^TTextAttr;
TYPE p_TextFont = ^TextFont;
TYPE p_TextFontExtension = ^TextFontExtension;
TYPE p_ColorTextFont = ^ColorTextFont;
TYPE p_ColorFontColors = ^ColorFontColors;
TYPE p_TextExtent = ^_TextExtent;

{$if not def EXEC_PORTS_H;incl "exec/ports.h";endif}
{$if not def GRAPHICS_GFX_H;incl "graphics/gfx.h";endif}
{$if not def UTILITY_TAGITEM_H;incl "utility/tagitem.h";endif}

CONST
 FS_NORMAL      = 0;
 FSB_UNDERLINED = 0;
 FSF_UNDERLINED = $01;
 FSB_BOLD       = 1;
 FSF_BOLD       = $02;
 FSB_ITALIC     = 2;
 FSF_ITALIC     = $04;
 FSB_EXTENDED   = 3;
 FSF_EXTENDED   = $08;

 FSB_COLORFONT  = 6;
 FSF_COLORFONT  = $40;
 FSB_TAGGED     = 7;
 FSF_TAGGED     = $80;

CONST
 FPB_ROMFONT      = 0;
 FPF_ROMFONT      = $01;
 FPB_DISKFONT     = 1;
 FPF_DISKFONT     = $02;
 FPB_REVPATH      = 2;
 FPF_REVPATH      = $04;
 FPB_TALLDOT      = 3;
 FPF_TALLDOT      = $08;
 FPB_WIDEDOT      = 4;
 FPF_WIDEDOT      = $10;
 FPB_PROPORTIONAL = 5;
 FPF_PROPORTIONAL = $20;
 FPB_DESIGNED     = 6;
 FPF_DESIGNED     = $40;
 FPB_REMOVED      = 7;
 FPF_REMOVED      = $80;

TYPE TextAttr = RECORD
 ta_Name  : Str;
 ta_YSize : Word;
 ta_Style : Byte;
 ta_Flags : Byte;
END;

TYPE TTextAttr = RECORD
 tta_Name  : Str;
 tta_YSize : Word;
 tta_Style : Byte;
 tta_Flags : Byte;
 tta_Tags  : p_TagItem;
END;


CONST TA_DeviceDPI = (TAG_USER+1);

CONST MAXFONTMATCHWEIGHT = 32767;


TYPE TextFont = RECORD
 tf_Message   : Message;
 tf_YSize     : Word;
 tf_Style     : Byte;
 tf_Flags     : Byte;
 tf_XSize     : Word;
 tf_Baseline  : Word;
 tf_BoldSmear : Word;
 tf_Accessors : Word;
 tf_LoChar    : Byte;
 tf_HiChar    : Byte;
 tf_CharData  : Ptr;
 tf_Modulo    : Word;
 tf_CharLoc   : Ptr;
 tf_CharSpace : Ptr;
 tf_CharKern  : Ptr;
END; { ** Bemerkung : tf_Extension=tf_Message.mn_ReplyPort }

CONST
 TE0B_NOREMFONT  = 0;
 TE0F_NOREMFONT  = $01;

TYPE TextFontExtension = RECORD
 tfe_MatchWord     : Word;
 tfe_Flags0        : Byte;
 tfe_Flags1        : Byte;
 tfe_BackPtr       : p_TextFont;
 tfe_OrigReplyPort : p_MsgPort;
 tfe_Tags          : p_TagItem;
 tfe_OFontPatchS   : Ptr;
 tfe_OFontPatchK   : Ptr;
END;

CONST
 CT_COLORMASK  = $000F;
 CT_COLORFONT  = $0001;
 CT_GREYFONT   = $0002;
 CT_ANTIALIAS  = $0004;
 CTB_MAPCOLOR  = 0;
 CTF_MAPCOLOR  = $0001;


TYPE ColorFontColors = RECORD
 cfc_Reserved   : Word;
 cfc_Count      : Word;
 cfc_ColorTable : Ptr;
END;

TYPE ColorTextFont = RECORD
 ctf_TF              : TextFont;
 ctf_Flags           : Word;
 ctf_Depth           : Byte;
 ctf_FgColor         : Byte;
 ctf_Low             : Byte;
 ctf_High            : Byte;
 ctf_PlanePick       : Byte;
 ctf_PlaneOnOff      : Byte;
 ctf_ColorFontColors : p_ColorFontColors;
 ctf_CharData        : ARRAY[0..7] OF Ptr;
END;

TYPE _TextExtent = RECORD
 te_Width  : Word;
 te_Height : Word;
 te_Extent : Rectangle;
END;

{$endif}
